<?php
namespace Incoviba\Service;

use DateTimeInterface;
use DateTimeImmutable;
use Incoviba\Common\Implement\Exception\EmptyRedis;

class UF
{
    protected string $redisKey = 'uf';

    public function __construct(protected Redis $redisService, protected Money $moneyService) {}

    public function get(?DateTimeInterface $date = null): float
    {
        if ($date === null) {
            $date = new DateTimeImmutable();
        }
        $ufs = [];
        try {
            $ufs = json_decode($this->redisService->get($this->redisKey), JSON_OBJECT_AS_ARRAY);
            if (!isset($ufs[$date->format('Y-m-d')])) {
                throw new EmptyRedis($this->redisKey);
            }
            $uf = $ufs[$date->format('Y-m-d')];
        } catch (EmptyRedis) {
            $uf = $this->moneyService->getUF($date);
            $ufs[$date->format('Y-m-d')] = $uf;
            ksort($ufs);
            $this->redisService->set($this->redisKey, json_encode($ufs), 60 * 60 * 24 * 30);
        }
        return $uf;
    }
    public function transform(DateTimeInterface $date, float $input, string $from = 'uf'): float
    {

        $uf = $this->get($date);
        return $input * (($from === 'uf') ? $uf : 1/$uf);
    }
}
